#include "plotstyle/bes3plotstyle.C"

void myFormatAxis( RooPlot *hist, int num)
{
  if( num==1 ) {
    hist->GetYaxis()->SetTitleOffset(1.0); 
    hist->GetXaxis()->SetTitleOffset(1.0);
    hist->GetXaxis()->CenterTitle();
    hist->GetYaxis()->CenterTitle();
  //hist->GetXaxis()->SetNdivisions(505);
    hist->SetMarkerStyle(20); 
    hist->GetXaxis()->SetLabelSize(0.05);  
    hist->GetYaxis()->SetLabelSize(0.05);
  } else if( num==2 ) {
    hist->SetMarkerSize(0.05);               
    hist->GetXaxis()->SetLabelSize(0.15);    
    hist->GetXaxis()->SetTitleOffset(2.0);  
    hist->GetYaxis()->SetLabelSize(0.15); 
    hist->GetYaxis()->SetTitle("Pull");
    hist->GetXaxis()->SetTitle(""); 
    hist->GetYaxis()->CenterTitle();
    hist->GetYaxis()->SetTitleFont(42);
    hist->GetYaxis()->SetTitleColor(1);
    hist->GetYaxis()->SetTitleSize(0.2);
    hist->GetYaxis()->SetTitleOffset(0.2);   
    hist->GetYaxis()->SetNdivisions(504);
  }
}
 

void fitM_LcRef_CTall(const int stFlag=1)  
{
  SetStyle();
  SetPrelimStyle();
  TGaxis::SetMaxDigits(3);
//gStyle->SetPadRightMargin(0.08);
  gStyle->SetPadTopMargin(0.08);
  gStyle->SetOptStat(0);
  gStyle->SetFillStyle(0);  

  using namespace RooFit;
  RooMsgService::instance().deleteStream(0) ;
  RooMsgService::instance().deleteStream(1) ;
  RooMsgService::instance().Print() ;
  cout << endl ;

  TChain *tree0= new TChain("tree0");
  tree0->Add("./DumpROOT/LcRef_genericMC.root/treeAll");

  TChain *tree= new TChain("tree");
  TString stCut = "massLc>0";
  if(stFlag<=4 && stFlag>=0 ) {
    //0: all MC15rd; 1-4: s1-s4
    tree->Add("DumpROOT/LcRef_genericMC.root/treeAll");
    if( stFlag==0 ) stCut = "stNo>0"; 
    else if( stFlag==1 ) stCut = "stNo==1"; 
    else if( stFlag==2 ) stCut = "stNo==2"; 
    else if( stFlag==3 ) stCut = "stNo==3"; 
    else if( stFlag==4 ) stCut = "stNo==4"; 
  } else {
    //cout<<"Wrong arguement [0-4]...."<<endl; return;
    tree->Add("DumpROOT/LcRef_data.root/treeAll");
  } 
  //double Nmax = tree->GetEntries(); 
  //cout<<"Total Input events No. = "<< Nmax <<endl;
  
  int nbin(100);
  double mMean(2.28646), mFitMin(2.15), mFitMax(2.45);

  // DATA SAMPLE
  RooRealVar massLc("massLc","M(Lc)", mFitMin, mFitMax, "GeV/c^{2}");
  RooRealVar stNo("stNo","stream No. flag", -1, 10 );
  RooRealVar sigFlag("sigFlag","MC flag", -1, 10 ); 
  RooDataSet *Data = new RooDataSet("Data","data sample", RooArgSet(massLc, stNo, sigFlag), Import(*tree), Cut(stCut) );
  double Nmax = Data->numEntries(); 
  cout<<"Total Input events No. = "<<std::setprecision(8) << Nmax <<endl;
   
  RooRealVar mmu1("mmu1", "mass Lc", 2.28664e+00, 2.27, 2.31 );
  RooRealVar sigma1("sigma1", "sigma1", 3.02832e-03, 0.001, 0.02 );
  RooRealVar dsig1("dsig1", "dsig1", 1.62506e-02, -0.69 , 0.69 );
  RooFormulaVar sig1L("sig1L", "", "sigma1*(1.0+dsig1)", RooArgList(sigma1, dsig1));
  RooFormulaVar sig1R("sig1R", "", "sigma1*(1.0-dsig1)", RooArgList(sigma1, dsig1));
  RooBifurGauss gauss1("gauss1","gauss1 PDF", massLc, mmu1, sig1L, sig1R );
   
  RooRealVar rsig2o1("rsig2o1", "rsig2o1", 2.09683e+00, 1.0, 8.0 );
  RooFormulaVar sigma2("sigma2", "", "sigma1*rsig2o1", RooArgList(sigma1, rsig2o1));
  RooRealVar dsig2("dsig2", "dsig2", 6.80213e-02, -0.89 , 0.89 );
  RooFormulaVar sig2L("sig2L", "", "sigma2*(1.0+dsig2)", RooArgList(sigma2, dsig2));
  RooFormulaVar sig2R("sig2R", "", "sigma2*(1.0-dsig2)", RooArgList(sigma2, dsig2));
  RooBifurGauss gauss2("gauss2","gauss2 PDF", massLc, mmu1, sig2L, sig2R );
   
  RooRealVar rsig3o2("rsig3o2", "rsig3o2", 2.87327e+00, 1.0, 10.0 );
  RooFormulaVar sigma3("sigma3", "", "sigma2*rsig3o2", RooArgList(sigma2, rsig3o2));
  RooRealVar dsig3("dsig3", "dsig3", 1.61447e-01, -0.89 , 0.89 );
  RooFormulaVar sig3L("sig3L", "", "sigma3*(1.0+dsig3)", RooArgList(sigma3, dsig3));
  RooFormulaVar sig3R("sig3R", "", "sigma3*(1.0-dsig3)", RooArgList(sigma3, dsig3));
  RooBifurGauss gauss3("gauss3","gauss3 PDF", massLc, mmu1, sig3L, sig3R );
   
  RooRealVar rsig4o3("rsig4o3", "rsig4o3", 3.76611e+00, 1.0, 10.0 );
  RooFormulaVar sigma4("sigma4", "", "sigma3*rsig4o3", RooArgList(sigma3, rsig4o3));
  RooRealVar dsig4("dsig4", "dsig4", 3.32416e-01, -0.89 , 0.89 );
  RooFormulaVar sig4L("sig4L", "", "sigma4*(1.0+dsig4)", RooArgList(sigma4, dsig4));
  RooFormulaVar sig4R("sig4R", "", "sigma4*(1.0-dsig4)", RooArgList(sigma4, dsig4));
  RooBifurGauss gauss4("gauss4","gauss4 PDF", massLc, mmu1, sig4L, sig4R );
 
  RooRealVar sig1frac("sig1frac","fraction in 1stgaus", 7.15480e-01, 0.3, 0.9 );
  RooRealVar sig2frac("sig2frac","fraction in 12gauss", 9.31689e-01, 0.6, 1.0 );
  RooRealVar sig3frac("sig3frac","fraction of 123gaus", 9.74135e-01, 0.8, 1.0 );
   
  RooAddPdf sigPDF12("sigPDF12", "two-gaussian", RooArgList(gauss1,gauss2),RooArgList(sig1frac ) );
  RooAddPdf sigPDF123("sigPDF123", "three-gaussian", RooArgList(sigPDF12,gauss3),RooArgList(sig2frac) );
  RooAddPdf sigPDF("sigPDF", "four-gaussian", RooArgList(sigPDF123,gauss4),RooArgList(sig3frac) );

  dsig1.setVal(1.61894e-02); dsig1.setConstant(kTRUE);
  dsig2.setVal(6.80661e-02); dsig2.setConstant(kTRUE);
  dsig3.setVal(1.61657e-01); dsig3.setConstant(kTRUE);
  dsig4.setVal(3.31839e-01); dsig4.setConstant(kTRUE);
  mmu1.setVal(2.28664e+00);  //mmu1.setConstant(kTRUE);
  rsig2o1.setVal(2.09694e+00); rsig2o1.setConstant(kTRUE);
  rsig3o2.setVal(2.87048e+00); rsig3o2.setConstant(kTRUE);
  rsig4o3.setVal(3.76327e+00); rsig4o3.setConstant(kTRUE);
  sig1frac.setVal(7.15912e-01); sig1frac.setConstant(kTRUE);
  sig2frac.setVal(9.31700e-01); sig2frac.setConstant(kTRUE);
  sig3frac.setVal(9.74127e-01); sig3frac.setConstant(kTRUE);
  sigma1.setVal(3.02953e-03);   //sigma1.setConstant(kTRUE);

  //======= for Sigma0 feeddown=====
  RooDataSet *bkg2_Data = new RooDataSet("bkg2_Data","data sample", RooArgSet(massLc, sigFlag), Import(*tree0), Cut("sigFlag==3") );
  massLc.setBins( nbin ) ;
  RooDataHist* hist2 = new RooDataHist("hist2", "", RooArgSet(massLc), *bkg2_Data);
  RooHistPdf bkgFeedPDF("bkgFeedPDF","bkgFeedPDF", massLc, *hist2, 2) ; 
 
  //======= for Xic feeddown bkg =======
  RooDataSet *bkg3_Data = new RooDataSet("bkg3_Data","data sample", RooArgSet(massLc, sigFlag), Import(*tree0), Cut("sigFlag==2") );
  massLc.setBins( nbin ) ;
  RooDataHist* hist3 = new RooDataHist("hist3", "", RooArgSet(massLc), *bkg3_Data);
  RooHistPdf bkgXicPDF("bkgXicPDF","bkgXicPDF", massLc, *hist3, 2) ; 

/*//======= for (misPID) LcToLamKp  =======
  RooDataSet *bkg4_Data = new RooDataSet("bkg4_Data","data sample", RooArgSet(massLc, sigFlag), Import(*tree0), Cut("sigFlag==4") );
//RooKeysPdf bkgmisPIDPDF("bkgmisPIDPDF", "", massLc, *bkg4_Data, RooKeysPdf::MirrorBoth, 1 );
  massLc.setBins( nbin ) ;
  RooDataHist* hist4 = new RooDataHist("hist4", "", RooArgSet(massLc), *bkg4_Data);
  RooHistPdf bkgmisPIDPDF("bkgmisPIDPDF","bkgmisPIDPDF", massLc, *hist4, 2) ; 
*/
  RooRealVar bkga1("bkga1", "bkga1",  2.95311e-02, -1.10, 1.10 ); 
  RooRealVar bkga2("bkga2", "bkga2", -7.08779e-02, -0.50, 0.50 ); 
//RooChebychev bkgOtherPDF( "bkgOtherPDF", "poly PDF", massLc, RooArgList( bkga1 ) );
  RooChebychev bkgOtherPDF( "bkgOtherPDF", "poly PDF", massLc, RooArgList( bkga1, bkga2 ) );

  bkga1.setVal(-2.09180e-01);  //bkga1.setConstant(kTRUE);
  bkga2.setVal(2.56451e-02);  //bkga2.setConstant(kTRUE);


  // combined PDF
  RooRealVar Nsig("Nsig","number of signal", 0.1763*Nmax, 0.1*Nmax, 0.40*Nmax );
  RooRealVar Nbkg2("Nbkg2","number of background", 0.1449*Nmax, 0.1*Nmax, 0.26*Nmax );
  RooRealVar Nbkg3("Nbkg3","number of background", 0.0079*Nmax, 0.00*Nmax, 0.02*Nmax );
  RooRealVar Nbkg4("Nbkg4","number of background", 0.0053*Nmax, 0.00*Nmax, 0.05*Nmax );
  RooRealVar Nbkg5("Nbkg5","number of background", 0.6704*Nmax, 0.50*Nmax, 0.80*Nmax );
 
//RooAddPdf sumpdf("sumpdf", "sum of pdf", RooArgList( sigPDF, bkgFeedPDF, bkgXicPDF, bkgmisPIDPDF, bkgOtherPDF ), RooArgList(Nsig, Nbkg2, Nbkg3, Nbkg4, Nbkg5));
  RooAddPdf sumpdf("sumpdf", "sum of pdf", RooArgList( sigPDF, bkgFeedPDF, bkgXicPDF, bkgOtherPDF ), RooArgList(Nsig, Nbkg2, Nbkg3, Nbkg5));
   
  sumpdf.fitTo(*Data, Strategy(2), Hesse(kFALSE), Save(kTRUE), Minos(kFALSE) ) ;
  RooFitResult *fiter = sumpdf.fitTo(*Data, Strategy(2), Hesse(kTRUE), Save(kTRUE), Minos(kFALSE) ) ;
  double npar = fiter->floatParsFinal().getSize();
  double Vlikelihood = fiter->minNll();
  cout<<"N(free par)= "<< npar <<endl;
  printf("minimized -log(L) = %.2f\n", Vlikelihood );
  printf("N(sig LcToLamPip)= %.0f \\pm %.0f\n", Nsig.getVal(), Nsig.getError() );  
  printf("N(bkg LcToSigPip)= %.0f \\pm %.0f\n", Nbkg2.getVal(), Nbkg2.getError() );
  printf("N(bkg XicToXiPip)= %.0f \\pm %.0f\n", Nbkg3.getVal(), Nbkg3.getError() );
//printf("N(bkg LcToLamKp)= %.0f \\pm %.0f\n", Nbkg4.getVal(), Nbkg4.getError() );
  printf("N(bkg others)= %.0f \\pm %.0f\n", Nbkg5.getVal(), Nbkg5.getError() );
   
  // ------------------------------------------------------------- //
  // PLOTS (ALL FIT REGION)
  // Observable
  RooPlot* varFrameFit = massLc.frame(Title("Signal"),Bins(nbin));
  Data->plotOn(varFrameFit, DataError(RooAbsData::SumW2), MarkerSize(1.0), RooFit::Name("Mproj"));
  sumpdf.plotOn(varFrameFit, LineWidth(2), LineColor(2));
//Data->statOn(varFrameFit, Layout(0.68,0.99,0.95), Format("N",4));
  if( stFlag==1 ) {
    sumpdf.paramOn(varFrameFit, Layout(0.58, 0.92, 0.92) ); //L,R,U 
    varFrameFit->getAttText()->SetTextSize(0.04);
  }
  varFrameFit->SetFillColor(0);
  varFrameFit->SetFillStyle(0);
  // ------------------------------------------------------------- //
  cout << "chi^2("<< npar <<") = " << varFrameFit->chiSquare( npar ) << endl ;
  //-------------------------------------------------------------- //
  // Residual
  RooHist* hpull = varFrameFit->pullHist() ;
  RooPlot* framePull = massLc.frame( Title("Pull") ) ;
  hpull->SetFillColor(15);
  hpull->SetLineColor(0);
  framePull->addPlotable( hpull, "B" );
  framePull->GetYaxis()->SetRangeUser( -4.0, 4.0 );
  if( stFlag>4 ) framePull->GetYaxis()->SetRangeUser( -6.0, 6.0 );

  sumpdf.plotOn(varFrameFit, Components(sigPDF), LineStyle(2), LineColor(2), RooFit::Name("Mfitsig"));
  sumpdf.plotOn(varFrameFit, Components(bkgFeedPDF), LineStyle(2), LineColor(4), RooFit::Name("Mfitbkg2"));
  sumpdf.plotOn(varFrameFit, Components(bkgXicPDF), LineStyle(2), LineColor(6), RooFit::Name("Mfitbkg3"));
//sumpdf.plotOn(varFrameFit, Components(bkgmisPIDPDF), LineStyle(2), LineColor(7), RooFit::Name("Mfitbkg4"));
  sumpdf.plotOn(varFrameFit, Components(bkgOtherPDF), LineStyle(2), LineColor(8), RooFit::Name("Mfitbkg5"));
  sumpdf.plotOn(varFrameFit, LineWidth(2), LineColor(2), RooFit::Name("Mfitall"));

  TCanvas* cav1 = new TCanvas("cav1","mc M(D) fit", 600, 500 );
  TPad *pad1 = new TPad("pad1","pad1",0.01,0.20,0.99,0.99);
  TPad *pad2 = new TPad("pad2","pad2",0.01,0.01,0.99,0.20);
  pad1->Draw();
  pad2->Draw();
 
  pad1->cd();
  pad1->SetLeftMargin(0.15);
  myFormatAxis( varFrameFit, 1 );
  varFrameFit->GetYaxis()->SetTitle("Events / (3 MeV/#it{c}^{2})");
  varFrameFit->GetXaxis()->SetTitle("M(#Lambda_{c}^{+}) (GeV/#it{c}^{2})");
  varFrameFit->GetYaxis()->SetRangeUser(0, varFrameFit->GetMaximum()*1.05);
  varFrameFit->Draw();

  double legxmin=0.60, legxmax=0.90; 
  if( stFlag==1 ) { legxmin=0.20; legxmax=0.55; }
//TLegend *leg = new TLegend( legxmin, 0.5, legxmax, 0.88 ); 
  TLegend *leg = new TLegend( legxmin, 0.58, legxmax, 0.88 ); 
  if( stFlag<=4 ) leg->AddEntry( varFrameFit->findObject("Mproj"), "Generic MC", "EP");
  else if( stFlag>4 ) leg->AddEntry( varFrameFit->findObject("Mproj"), "Data", "EP");
  leg->AddEntry( varFrameFit->findObject("Mfitall"), "Total fit", "l");
  leg->AddEntry( varFrameFit->findObject("Mfitsig"), "Signal", "l");
  leg->AddEntry( varFrameFit->findObject("Mfitbkg2"), "Bkg #Lambda_{c}^{+}#rightarrow#Sigma^{0}#pi^{+}", "l");
//leg->AddEntry( varFrameFit->findObject("Mfitbkg3"), "Bkg #Xi_{c}^{+,0}#rightarrow#Xi^{0,-}#pi^{+}", "l");
  leg->AddEntry( varFrameFit->findObject("Mfitbkg3"), "Bkg #Xi_{c}#rightarrow#Xi#pi^{+}", "l");
//leg->AddEntry( varFrameFit->findObject("Mfitbkg4"), "Bkg #Lambda_{c}^{+}#rightarrow#LambdaK^{+}", "l");
  leg->AddEntry( varFrameFit->findObject("Mfitbkg5"), "Bkg others", "l");
  leg->SetFillStyle(0);
  leg->SetTextFont(42);
  leg->Draw();

  pad2->cd();
  pad2->SetLeftMargin(0.15);
  myFormatAxis( framePull, 2 );
  framePull->Draw();
  PullLine( mFitMin, mFitMax );

  cav1->cd();
  if( stFlag<=4 && stFlag>=0 ) {
    cav1->Print(Form("./eps/Massfit_LcRef_genericMC_s%d_All.eps", stFlag));
  } else {
    cav1->Print("./eps/Massfit_LcRef_Data_All.eps");
  }
  
}
