#include "/gpfs/home/belle/lilongke/plotstyle/bes3plotstyle.C"

void myFormatAxis( RooPlot *hist, int num)
{
  if( num==1 ) {
    hist->GetYaxis()->SetTitleOffset(1.0); 
    hist->GetXaxis()->SetTitleOffset(1.0);
    hist->GetXaxis()->CenterTitle();
    hist->GetYaxis()->CenterTitle();
  //hist->GetXaxis()->SetNdivisions(505);
    hist->GetXaxis()->SetLabelSize(0.05);  
    hist->GetYaxis()->SetLabelSize(0.05);
  } else if( num==2 ) {
    hist->SetMarkerSize(0.05);               
    hist->GetXaxis()->SetLabelSize(0.15);    
    hist->GetXaxis()->SetTitleOffset(2.0);  
    hist->GetYaxis()->SetLabelSize(0.15); 
    hist->GetYaxis()->SetTitle("Pull");
    hist->GetXaxis()->SetTitle(""); 
    hist->GetYaxis()->CenterTitle();
    hist->GetYaxis()->SetTitleFont(42);
    hist->GetYaxis()->SetTitleColor(1);
    hist->GetYaxis()->SetTitleSize(0.2);
    hist->GetYaxis()->SetTitleOffset(0.2);   
    hist->GetYaxis()->SetNdivisions(504);
  }
}
 

void fitM_sig_Ref(const int CSflag=3)  
{
  //channel: (Lc+ SCS)1/(Lc+ CF)2/(Lc+ Ref)3   
  if( CSflag==3 )  cout<<"For (Ref) Lc+ -> Lambda pi+ ....."<<endl;
  else return; 

  SetStyle();
  SetPrelimStyle();
//TGaxis::SetMaxDigits(3);
//gStyle->SetPadRightMargin(0.08);
//gStyle->SetPadTopMargin(0.08);
  gStyle->SetOptStat(0);
  gStyle->SetFillStyle(0);  

  using namespace RooFit;
  RooMsgService::instance().deleteStream(0) ;
  RooMsgService::instance().deleteStream(1) ;
  RooMsgService::instance().Print() ;
  cout << endl ;

  TChain *tree= new TChain("tree");
  TString stCut = "sigFlag==1";
  tree->Add("DumpROOT/LcRef_genericMC.root/treeAll");
  

  int nbin(90);
  double mMean(2.28646), mFitMin(2.245), mFitMax(2.335);
  if( CSflag==3 ) { nbin=150; mFitMin=2.15; mFitMax=2.45; }

  // DATA SAMPLE
  RooRealVar massLc("massLc","M(D)", mFitMin, mFitMax, "GeV/c^{2}");
  RooRealVar sigFlag("sigFlag","stream No. flag", -1, 10 );
  RooDataSet *Data = new RooDataSet("Data","data sample", RooArgSet(massLc, sigFlag), Import(*tree), Cut(stCut) );
  double Nmax = Data->numEntries(); 
  cout<<"Total Input events No. = "<<std::setprecision(8) << Nmax <<endl;

  RooRealVar mmu1("mmu1", "mass Lc", 2.28664e+00, 2.27, 2.31 );
  RooRealVar sigma1("sigma1", "sigma1", 3.02946e-03, 0.001, 0.02 );
  RooRealVar dsig1("dsig1", "dsig1", 1.61781e-02, -0.69 , 0.69 );
  RooFormulaVar sig1L("sig1L", "", "sigma1*(1.0+dsig1)", RooArgList(sigma1, dsig1));
  RooFormulaVar sig1R("sig1R", "", "sigma1*(1.0-dsig1)", RooArgList(sigma1, dsig1));
  RooBifurGauss gauss1("gauss1","gauss1 PDF", massLc, mmu1, sig1L, sig1R );
   
  RooRealVar rsig2o1("rsig2o1", "rsig2o1", 2.09688e+00, 1.0, 8.0 );
  RooFormulaVar sigma2("sigma2", "", "sigma1*rsig2o1", RooArgList(sigma1, rsig2o1));
  RooRealVar dsig2("dsig2", "dsig2", 6.80626e-02, -0.89 , 0.89 );
  RooFormulaVar sig2L("sig2L", "", "sigma2*(1.0+dsig2)", RooArgList(sigma2, dsig2));
  RooFormulaVar sig2R("sig2R", "", "sigma2*(1.0-dsig2)", RooArgList(sigma2, dsig2));
  RooBifurGauss gauss2("gauss2","gauss2 PDF", massLc, mmu1, sig2L, sig2R );
   
  RooRealVar rsig3o2("rsig3o2", "rsig3o2", 2.87078e+00, 1.0, 10.0 );
  RooFormulaVar sigma3("sigma3", "", "sigma2*rsig3o2", RooArgList(sigma2, rsig3o2));
  RooRealVar dsig3("dsig3", "dsig3", 1.61659e-01, -0.89 , 0.89 );
  RooFormulaVar sig3L("sig3L", "", "sigma3*(1.0+dsig3)", RooArgList(sigma3, dsig3));
  RooFormulaVar sig3R("sig3R", "", "sigma3*(1.0-dsig3)", RooArgList(sigma3, dsig3));
  RooBifurGauss gauss3("gauss3","gauss3 PDF", massLc, mmu1, sig3L, sig3R );
   
  RooRealVar rsig4o3("rsig4o3", "rsig4o3", 3.76385e+00, 1.0, 10.0 );
  RooFormulaVar sigma4("sigma4", "", "sigma3*rsig4o3", RooArgList(sigma3, rsig4o3));
  RooRealVar dsig4("dsig4", "dsig4", 3.32416e-01, -0.89 , 0.89 );
  RooFormulaVar sig4L("sig4L", "", "sigma4*(1.0+dsig4)", RooArgList(sigma4, dsig4));
  RooFormulaVar sig4R("sig4R", "", "sigma4*(1.0-dsig4)", RooArgList(sigma4, dsig4));
  RooBifurGauss gauss4("gauss4","gauss4 PDF", massLc, mmu1, sig4L, sig4R );

  RooRealVar sig1frac("sig1frac","fraction in 1stgaus", 7.15877e-01, 0.5, 0.9 );
  RooRealVar sig2frac("sig2frac","fraction in 12gauss", 9.31696e-01, 0.6, 1.0 );
  RooRealVar sig3frac("sig3frac","fraction of 123gaus", 9.74130e-01, 0.8, 1.0 );
   
  RooAddPdf sumpdf12("sumpdf12", "two-gaussian", RooArgList(gauss1,gauss2),RooArgList(sig1frac ) );
  RooAddPdf sumpdf123("sumpdf123", "three-gaussian", RooArgList(sumpdf12,gauss3),RooArgList(sig2frac) );
  RooAddPdf sumpdf("sumpdf", "four-gaussian", RooArgList(sumpdf123,gauss4),RooArgList(sig3frac) );
   
  //fit data with unbinned maximum likelihood method
  sumpdf.fitTo(*Data, Strategy(2), Hesse(kFALSE), Save(kTRUE), Minos(kFALSE) ) ;
  RooFitResult *fiter = sumpdf.fitTo(*Data, Strategy(2), Hesse(kTRUE), Save(kTRUE), Minos(kFALSE) ) ;
  double npar = fiter->floatParsFinal().getSize();
  double Vlikelihood = fiter->minNll();
  cout<<"N(free par)= "<< npar <<endl;
  printf("minimized -log(L) = %.2f\n", Vlikelihood );
   
  // ------------------------------------------------------------- //
  // PLOTS (ALL FIT REGION)
  // Observable
  RooPlot* varFrameFit = massLc.frame(Title("Signal"),Bins(nbin));
  Data->plotOn(varFrameFit, DataError(RooAbsData::SumW2), MarkerSize(1.0));
//Data->statOn(varFrameFit, Layout(0.68,0.99,0.95), Format("N",4));
  sumpdf.plotOn(varFrameFit, LineWidth(2), LineColor(2));
//sumpdf.paramOn(varFrameFit, Layout(0.55, 0.90, 0.90) ); //L,R,U 
//varFrameFit->getAttText()->SetTextSize(0.04);
//varFrameFit->SetFillColor(0);
//varFrameFit->SetFillStyle(0);
  // ------------------------------------------------------------- //
  cout << "chi^2("<< npar <<") = " << varFrameFit->chiSquare( npar ) << endl ;
  //-------------------------------------------------------------- //
  // Residual
  RooHist* hpull = varFrameFit->pullHist() ;
  RooPlot* framePull = massLc.frame( Title("Pull") ) ;
  hpull->SetFillColor(15);
  hpull->SetLineColor(0);
  framePull->addPlotable( hpull, "B" );
  framePull->GetYaxis()->SetRangeUser( -4.0, 4.0 );

  sumpdf.plotOn(varFrameFit, Components(gauss1), LineStyle(2), LineColor(2));
  sumpdf.plotOn(varFrameFit, Components(gauss2), LineStyle(3), LineColor(4));
  sumpdf.plotOn(varFrameFit, Components(gauss3), LineStyle(3), LineColor(6));
  sumpdf.plotOn(varFrameFit, Components(gauss4), LineStyle(3), LineColor(8));
  sumpdf.plotOn(varFrameFit, LineWidth(2), LineColor(2));

  TCanvas* cav1 = new TCanvas("cav1","mc M(D) fit", 600, 500 );
  TPad *pad1 = new TPad("pad1","pad1",0.01,0.20,0.99,0.99);
  TPad *pad2 = new TPad("pad2","pad2",0.01,0.01,0.99,0.20);
  pad1->Draw();
  pad2->Draw();
 
  pad1->cd();
  pad1->SetLeftMargin(0.15);
  gPad->SetLogy(1); 
  myFormatAxis( varFrameFit, 1 );
  double ymin = 2 ; 
  varFrameFit->GetYaxis()->SetRangeUser(ymin, varFrameFit->GetMaximum()*1.5 );
  varFrameFit->GetYaxis()->SetTitle("Events / (2 MeV/#it{c}^{2})");
  varFrameFit->GetXaxis()->SetTitle("M(#Lambda_{c}^{+}) (GeV/#it{c}^{2})");
  varFrameFit->Draw();
  
  pad2->cd();
  pad2->SetLeftMargin(0.15);
  gPad->SetLogy(0); 
  myFormatAxis( framePull, 2 );
  framePull->Draw();
  PullLine( mFitMin, mFitMax );

  cav1->cd();
  if( CSflag==1 ) cav1->Print("./eps/Massfit_LcSCS_sig_3s.eps");
  else if( CSflag==2 ) cav1->Print("./eps/Massfit_LcCF_sig_3s.eps");
  else if( CSflag==3 ) cav1->Print("./eps/Massfit_LcRef_sig_3s.eps");
  
}
