{
  TH1D h1("h1", "h1", 50, -10, 10);

  TRandom3 randomGenerator(1);
  for (int i = 0; i < 1000; ++i) {
    h1.Fill(randomGenerator.Gaus(1, 2));
  }
  h1.Draw();

  auto f1 = new TF1("f1", "gaus", -10, 10); 
  f1->SetParameters(100, 0, 1);

  ROOT::Math::MinimizerOptions::SetDefaultMinimizer("Minuit2");
  auto res = h1.Fit(f1, "L S E");
  res->Print();

  auto corrMatrix = res->GetCorrelationMatrix();
  corrMatrix.Print();

  std::cout << "Gaussian sigma = " << f1->GetParameter("Sigma") << "  +/- "
            << f1->GetParError(f1->GetParNumber("Sigma")) << std::endl;
}
